3 USAGE='[-q] [-f] [-b <new_branch>] [-m] [<branch>] [<paths>...]'
4 SUBDIRECTORY_OK=Sometimes
9 old=$(git-rev-parse --verify $old_name 2>/dev/null)
10 oldbranch=$(git-symbolic-ref $old_name 2>/dev/null)
21 while [ "$#" != "0" ]; do
28 [ -z "$newbranch" ] &&
29 die "git checkout: -b needs a branch name"
30 git-show-ref --verify --quiet -- "refs/heads/$newbranch" &&
31 die "git checkout: branch $newbranch already exists"
32 git-check-ref-format "heads/$newbranch" ||
33 die "git checkout: we do not like '$newbranch' as a branch name."
54 if rev=$(git-rev-parse --verify "$arg^0" 2>/dev/null)
56 if [ -z "$rev" ]; then
57 echo "unknown flag $arg"
62 if git-show-ref --verify --quiet -- "refs/heads/$arg"
66 elif rev=$(git-rev-parse --verify "$arg^{tree}" 2>/dev/null)
68 # checking out selected paths from a tree-ish.
70 new_name="$arg^{tree}"
88 case "$force$merge" in
90 die "git checkout: -f and -m are incompatible"
93 # The behaviour of the command with and without explicit path
94 # parameters is quite different.
96 # Without paths, we are checking out everything in the work tree,
97 # possibly switching branches. This is the traditional behaviour.
99 # With paths, we are _never_ switching branch, but checking out
100 # the named paths from either index (when no rev is given),
101 # or the named tree-ish (when rev is given).
109 Did you intend to checkout '$@' which can not be resolved as commit?"
111 if test '' != "$newbranch$force$merge"
113 die "git checkout: updating paths is incompatible with switching branches/forcing$hint"
117 # from a specific tree-ish; note that this is for
118 # rescuing paths and is never meant to remove what
119 # is not in the named tree-ish.
120 git-ls-tree --full-name -r "$new" "$@" |
121 git-update-index --index-info || exit $?
124 # Make sure the request is about existing paths.
125 git-ls-files --error-unmatch -- "$@" >/dev/null || exit
126 git-ls-files -- "$@" |
127 git-checkout-index -f -u --stdin
130 # Make sure we did not fall back on $arg^{tree} codepath
131 # since we are not checking out from an arbitrary tree-ish,
132 # but switching branches.
135 git-rev-parse --verify "$new^{commit}" >/dev/null 2>&1 ||
136 die "Cannot switch branch to a non-commit."
140 # We are switching branches and checking out trees, so
141 # we *NEED* to be at the toplevel.
144 [ -z "$new" ] && new=$old && new_name="$old_name"
146 # If we don't have an existing branch that we're switching to,
147 # and we don't have a new branch name for the target we
148 # are switching to, then we are detaching our HEAD from any
149 # branch. However, if "git checkout HEAD" detaches the HEAD
150 # from the current branch, even though that may be logically
151 # correct, it feels somewhat funny. More importantly, we do not
152 # want "git checkout" nor "git checkout -f" to detach HEAD.
157 if test -z "$branch$newbranch" && test "$new" != "$old"
160 if test -n "$oldbranch" && test -z "$quiet"
162 detach_warn="Note: moving to \"$new_name\" which isn't a local branch
163 If you want to create a new branch from this checkout, you may do so
164 (now or later) by using -b with the checkout command again. Example:
165 git checkout -b <new_branch_name>"
167 elif test -z "$oldbranch" && test -z "$quiet"
169 echo >&2 "Previous HEAD position was $old"
176 echo >&2 "warning: You appear to be on a branch yet to be born."
177 echo >&2 "warning: Forcing checkout of $new_name."
184 git-read-tree --reset -u $new
186 git-update-index --refresh >/dev/null
187 merge_error=$(git-read-tree -m -u --exclude-per-directory=.gitignore $old $new 2>&1) || (
190 echo >&2 "$merge_error"
194 # Match the index to the working tree, and do a three-way.
195 git diff-files --name-only | git update-index --remove --stdin &&
196 work=`git write-tree` &&
197 git read-tree --reset -u $new || exit
199 eval GITHEAD_$new=${new_name:-${branch:-$new}} &&
200 eval GITHEAD_$work=local &&
201 export GITHEAD_$new GITHEAD_$work &&
202 git merge-recursive $old -- $new $work
204 # Do not register the cleanly merged paths in the index yet.
205 # this is not a real merge before committing, but just carrying
206 # the working tree changes along.
207 unmerged=`git ls-files -u`
208 git read-tree --reset $new
213 z40=0000000000000000000000000000000000000000
215 sed -e 's/^[0-7]* [0-9a-f]* /'"0 $z40 /"
217 ) | git update-index --index-info
223 if test "$saved_err" = 0 && test -z "$quiet"
225 git diff-index --name-status "$new"
231 # Switch the HEAD pointer to the new branch if we
232 # checked out a branch head, and remove any potential
233 # old MERGE_HEAD's (subsequent commits will clearly not
234 # be based on them, since we re-set the index)
236 if [ "$?" -eq 0 ]; then
237 if [ "$newbranch" ]; then
238 if [ "$newbranch_log" ]; then
239 mkdir -p $(dirname "$GIT_DIR/logs/refs/heads/$newbranch")
240 touch "$GIT_DIR/logs/refs/heads/$newbranch"
242 git-update-ref -m "checkout: Created from $new_name" "refs/heads/$newbranch" $new || exit
247 GIT_DIR="$GIT_DIR" git-symbolic-ref -m "checkout: moving to $branch" HEAD "refs/heads/$branch"
250 echo >&2 "Switched to${newbranch:+ a new} branch \"$branch\""
252 elif test -n "$detached"
254 # NEEDSWORK: we would want a command to detach the HEAD
255 # atomically, instead of this handcrafted command sequence.
257 # git update-ref --detach HEAD $new
258 # or something like that...
260 git-rev-parse HEAD >"$GIT_DIR/HEAD.new" &&
261 mv "$GIT_DIR/HEAD.new" "$GIT_DIR/HEAD" &&
262 git-update-ref -m "checkout: moving to $arg" HEAD "$detached" ||
263 die "Cannot detach HEAD"
264 if test -n "$detach_warn"
266 echo >&2 "$detach_warn"
269 rm -f "$GIT_DIR/MERGE_HEAD"